#include <string.h>
#include <dos.h>
#include <float.h>

#include "kernel.h"

#define CP_SIZE 108

/*
--------------------------------------------------------------------------------
Save/restore coprocessor context
--------------------------------------------------------------------------------
*/

static void
save(void *buf)
{
	asm
	{
		mov			eax, buf
		fsave		[eax]
		fwait
	}
}

static void
restore(void *buf)
{
	asm
	{
		mov			eax, buf
		frstor		[eax]
		fwait
	}
}

/*
--------------------------------------------------------------------------------
mt_setup_math:		Initialize module
mt_init_math:		Initialize a taks's math context
mt_save_math:		Save a taks's math context
mt_restore_math:	Restore a taks's math context
--------------------------------------------------------------------------------
*/

void
mt_setup_math(void)
{
}

void
mt_init_math(Task_t *task)
{
	if ( _8087 && !task->math_data )
	{
		task->math_data = Malloc(CP_SIZE);
		Atomic();
		save(task->math_data);
		Unatomic();
	}
}

void
mt_save_math(Task_t *task)
{
	save(task->math_data);
}

void
mt_restore_math(Task_t *task)
{
	restore(task->math_data);
}

